; Last Guardian II .lap extractor by Mok

	cpu	686
	use32

%define	b byte
%define	w word
%define	d dword

extern _GetCommandLineA
extern _MultiByteToWideChar
extern _CreateFileW
extern _CloseHandle
extern _SetFilePointer
extern _ReadFile
extern _WriteFile
extern _ExitProcess
extern _malloc
extern _free
extern _printf
extern _fwprintf
extern _SetConsoleOutputCP
extern _DosDateTimeToFileTime
extern _SetFileTime

	section .text

global start
start:
	push	65001
	call	_SetConsoleOutputCP		;set console to utf-8 output

	call	_GetCommandLineA
	mov	[CmdLine],eax
	mov	esi,eax
	mov	edi,FileName
	call	CopyString
	mov	edi,FileName
	mov	b [edi],0
	call	CopyString
;
	push	1024
	push	WideString
	push	-1
	push	FileName
	push	0
	push	0
	call	_MultiByteToWideChar

	mov	edx,WideString
	call	FileOpen
	jc	About
	mov	ebx,eax
	mov	[Handle],ebx
	mov	edx,Header
	mov	ecx,18h
	call	FileRead
	cmp	d [Header],'$_AP'
	jnz	ERROR

	movzx eax,w [Header+0Ah]
	shl	eax,5
	mov	[DirLen],eax
	push	eax
	call	_malloc
	pop	ecx
	test	eax,eax
	jz	ERROR
	mov	[DirMem],eax
	mov	edx,eax
	mov	ecx,[DirLen]
	call	FileRead
;
	mov	esi,[DirMem]
	movzx ebp,w [Header+0Ah]
MAINLOOP:
	mov	ebx,[Handle]
	mov	eax,[esi+18h]
	add	eax,[Header+0Ch]
	call	FileSeek
	movzx eax,w [esi+14h]
	mov	[LEN],eax
	push	eax
	call	_malloc
	pop	ecx
	test	eax,eax
	jz	ERROR
	mov	edi,eax
	mov	edx,eax
	mov	ecx,[LEN]
	call	FileRead
;
	cmp	w [edi],'_A'
	jnz	ERROR

	movzx eax,w [esi+12h]
	push	eax
	call	_malloc
	pop	ecx
	test	eax,eax
	jz	ERROR
	mov	[out_mem],eax
;
	push	esi
	push	edi
	push	ebp
	push	edi
	push	eax
	push	0
	call	DEPACK
	add	esp,3*4
	mov	[LEN],eax
	pop	ebp
	pop	edi
	pop	esi
	cmp	ax,w [esi+12h]
	jnz	ERROR
	push	edi
	call	_free
	pop	edi
	mov	edi,[out_mem]
;
	push	filetime
	movzx eax,w [esi+0Eh]
	push	eax
	movzx eax,w [esi+10h]
	push	eax
	call	_DosDateTimeToFileTime

	push	1024
	push	WideString
	push	-1
	push	esi
	push	0
	push	932		;shift-jis
	call	_MultiByteToWideChar

	push	esi
	push	d [resid]
	push	DumpTxt
	call	_printf
	add	esp,3*4
	inc	d [resid]

	mov	edx,WideString
	call	FileCreate
	jc	ERROR
	mov	ebx,eax
	mov	edx,edi
	mov	ecx,[LEN]
	call	FileWrite

	pushad
	push	filetime
	push	filetime
	push	filetime
	push	ebx
	call	_SetFileTime
	popad

	call	FileClose
	push	edi
	call	_free
	pop	eax




	add	esi,20h
	dec	ebp
	jnz	MAINLOOP
	jmp	ENDE
;
About:
	push	AboutTxt
	jmp	ERR
ERROR:
	push	ErrorTxt
ERR:
	call	_printf
	mov	b [ExitCode],1
ENDE:
	push	d [ExitCode]
	call	_ExitProcess
;
DEPACK:

%define extra_allocs -1018h
%define prev_dest -1014h
%define outlen -1010h
%define var3 -100Ch
%define var2 -1008h
%define var1 -1004h
%define _stack -1000h
%define _zero 8
%define dest_mem 0Ch
%define src_mem 10h

	enter 1100h, 0
	push	ds
	push	edi
	push	esi
	cld
	xor	eax, eax
	mov	[ebp+extra_allocs], eax
	mov	[ebp+prev_dest], eax
	mov	esi, [ebp+src_mem]

@@try_again:
	call	check_header
	jb	@@bad
	mov	[pack_type], dh
	cmp	dh, 2
	jnb	@@bad
	or	ax, ax
	jz	@@5E
	inc	d [ebp+extra_allocs]
	movzx eax, w [esi]
	push	eax
	call	_malloc
	pop	edi
	test	eax,eax
	jz	ERROR
	mov	edi, [ebp+dest_mem]
	mov	[ebp+dest_mem], eax
	mov	[ebp+prev_dest], edi
@@5E:
	mov	dh, [pack_type]
	test	dh, dh
	jz	@@dep_lz
	cmp	dh, 1
	jz	@@dep_non_lz
@@bad:
	xor	eax, eax
	jmp	@@bye
@@73:
	dec	d [ebp+extra_allocs]
	jnz	@@done
	mov	edi, [ebp+prev_dest]
	mov	esi, [ebp+dest_mem]
	mov	[ebp+prev_dest], esi
	mov	[ebp+dest_mem], edi
	jmp	@@try_again

@@done:							
	mov	eax, [ebp+prev_dest]
	test	eax, eax
	jz	@@no_need
	push	eax
	call	_free
	pop	eax
@@no_need:						
	mov	eax, [ebp+outlen]
@@bye:							
	pop	esi
	pop	edi
	pop	ds
	leave
	ret

@@dep_lz:							
	xor	eax, eax
	mov	d [ebp+var2], 0FEEh
	mov	[var_gs], eax
	mov	[ebp+var3], eax
	mov	[ebp+var1], eax
	mov	[ebp+outlen], eax
	mov	edx, eax
	lea	edi, [ebp+_stack]
	mov	ebx, edi
	mov	ecx, 400h
	rep	stosd
	mov	edi, [ebp+dest_mem]
	xor	eax,eax
	lodsw
	mov	ecx, [ebp+_zero]
	test	ecx, ecx
	jz	@@EF
	cmp	d [ebp+extra_allocs], 0
	jz	@@F1
@@EF:						
	mov	ecx, eax
@@F1:						
	mov	[ebp+outlen], ecx
@@F6:
	shr	dx, 1
	test	dh, 1
	jnz	@@102
	lodsb
	mov	dl, al
	dec	dh

@@102:						
	test	dl, 1
	jz	@@12E
	lodsb
	stosb
	inc	d [ebp+var1]
	mov	ecx, [ebp+var2]
	mov	[var_fs], ebx
	add	ebx, ecx
	mov	[ebx], al
	mov	ebx, [var_fs]
	inc	ecx
	and	ch, 0Fh
	mov	[ebp+var2], ecx
	mov	eax, [ebp+outlen]
	cmp	[ebp+var1], eax
	jb	@@F6
	jmp	@@192

@@12E:						
	mov	[var_fs], edx
	xor	eax, eax
	lodsb
	mov	ecx, eax
	lodsb
	mov	edx, eax
	and	al, 0F0h
	shl	ax, 4
	or	ecx, eax
	mov	[var_gs], ecx
	mov	eax, edx
	and	al, 0Fh
	inc	al
	inc	al
	mov	[ebp+var3], eax
	xor	ecx, ecx
	mov	edx, ebx
@@152:						
	mov	eax, [var_gs]
	add	eax, ecx
	and	ah, 0Fh
	add	ebx, eax
	mov	al, [ebx]
	stosb
	inc	d [ebp+var1]
	mov	ebx, edx
	add	ebx, [ebp+var2]
	mov	[ebx], al
	mov	ebx, edx
	mov	eax, [ebp+var2]
	inc	eax
	and	ah, 0Fh
	mov	[ebp+var2], eax
	mov	eax, [ebp+outlen]
	cmp	[ebp+var1], eax
	jnb	@@190
	inc	ecx
	cmp	ecx, [ebp+var3]
	jbe	@@152
	mov	edx, [var_fs]
	jmp	@@F6

@@190:						
	mov	edx, [var_fs]

@@192:						
	jmp	@@73

@@dep_non_lz:					
	mov	edi, [ebp+dest_mem]
	xor	eax, eax
	lodsw
	mov	ecx, [ebp+_zero]
	test	ecx, ecx
	jz	@@1A8
	cmp	d [ebp+extra_allocs], 0
	jz	@@1AA

@@1A8:						
	mov	ecx, eax

@@1AA:						
	xor	edx, edx
	mov	[ebp+outlen], ecx
	push	ebp
	push	edi
	lea	edi, [ebp+_stack]
	push	edi
	mov	ebp, 100h
	call	dep_1
	pop	ebp
	pop	edi
	jb	@@1F5
	mov	[var_fs], eax
	mov	[var_gs], ebp
@@1C6:
	mov	eax, [var_fs]
@@1C8:						
	cmp	ah, 1
	jnz	@@1EE
	mov	ebp, [var_gs]
	add	ebp, eax
	add	ebp, eax
	test	dl, dl
	jnz	@@1DD
	mov	dl, 8
	lodsb
	mov	dh, al

@@1DD:						
	dec	dl
	xor	eax, eax
	add	dh, dh
	jb	@@1E8
	mov	ax, [ebp]
	jmp	@@1C8

@@1E8:						
	mov	ax, [ebp+400h]
	jmp	@@1C8

@@1EE:						
	stosb
	loop	@@1C6
	pop	ebp
	jmp	@@73

@@1F5:						
	pop	ebp
	jmp	@@bad

dep_1:
	push	ebx
	xor	bl, bl
	test	dl, dl
	jnz	@@27B
	mov	dl, 8
	lodsb
	mov	dh, al

@@27B:						
	dec	dl
	add	dh, dh
	jnb	@@2A6
	mov	ebx, ebp
	inc	ebp
	cmp	bx, 1FFh
	jnb	@@2CC
	add	ebx, ebx
	call	dep_1
	jb	@@2CD
	mov	[ebx+edi], ax
	call	dep_1
	jb	@@2CD
	mov	[ebx+edi+400h], ax
	mov	eax, ebx
	shr	eax, 1
	clc
	pop	ebx
	ret
@@2A6:						
	mov	ah, 8
	mov	al, bl
@@2AA:						
	cmp	dl, bl
	jz	@@2BC
@@2AE:						
	add	dh, dh
	adc	al, al
	dec	dl
	dec	ah
	jz	@@2C9
	cmp	dl, bl
	jnz	@@2AA
@@2BC:						
	mov	dh, [esi]
	inc	esi
	add	dh, dh
	adc	al, al
	mov	dl, 7
	dec	ah
	jnz	@@2AE
@@2C9:						
	clc
	pop	ebx
	ret
@@2CC:
	stc
@@2CD:
	pop	ebx
	ret

check_header:
	lodsw
	cmp	ax, 415Fh
	jnz	@@bad
	lodsw
	mov	dx, ax
	lodsw
	lodsw
	cmp	dl, 46h ; 'F'
	jnz	@@bad
	sub	dh, 31h ; '1'
	clc
	ret

@@bad:
	stc
	ret
;
;	runtime
;
%define GENERIC_READ 80000000h
%define GENERIC_WRITE 40000000h
%define CREATE_ALWAYS 2
%define OPEN_EXISTING 3
%define OPEN_ALWAYS 4
%define TRUNCATE_EXISTING 5
%define FILE_SHARE_READ 1
%define FILE_SHARE_WRITE	2
%define FILE_BEGIN 0

FileOpen:
	push	edx
	xor	eax,eax
	push	eax
	push	eax
	push	OPEN_EXISTING
	push	eax
	push	FILE_SHARE_READ+FILE_SHARE_WRITE
	push	GENERIC_READ
	push	edx
	call	_CreateFileW
	pop	edx
	cmp	eax,-1
	jz	@@bad
	clc
	ret
@@bad:
	stc
	ret

FileCreate:
	push	edx
	push	0
	push	0
	push	CREATE_ALWAYS
	push	0
	push	0
	push	GENERIC_WRITE+GENERIC_READ
	push	edx
	call	_CreateFileW
	pop	edx
	cmp	eax,-1
	jz	@@bad
	clc
	ret
@@bad:
	stc
	ret
;
FileClose:
	test	ebx,ebx
	jz	short @@bye
	push	ebx
	call	_CloseHandle
@@bye:
	clc
	ret

FileRead:
	test	ebx,ebx
	jz	short @@error
	push	0
	mov	eax,esp
	push	0
	push	eax
	push	ecx
	push	edx
	push	ebx
	call	_ReadFile
	test	eax,eax
	pop	eax
	jz	short @@error
	clc
	ret
@@error:
	xor	eax,eax
	stc
	ret

FileWrite:
	test	ebx,ebx
	jz	short @@error
	push	0
	mov	eax,esp
	push	0
	push	eax
	push	ecx
	push	edx
	push	ebx
	call	_WriteFile
	test	eax,eax
	pop	eax
	jz	short @@error
	clc
	ret
@@error:
	xor	eax,eax
	stc
	ret
;
FileSeek:
	test	ebx,ebx
	jz	short @@error
	push	ecx
	push	0
	mov	ecx,esp
	push	FILE_BEGIN
	push	ecx
	push	eax
	push	ebx
	call	_SetFilePointer
	pop	ecx
	pop	ecx
	cmp	eax,-1
	jz	short @@error
	clc
	ret
@@error:
	stc
	ret
;
CopyString:
	mov	al,[esi]
	cmp	al,' '
	ja	@@notsp
	jz	@@skip
	cmp	al,9
	jnz	@@notsp
@@skip:
	inc	esi
	jmp	CopyString
@@notsp:
	mov	al,[esi]
	inc	esi
	cmp	al,'"'
	jnz	@@juststore
@@cs1:
	lodsb
	stosb
	cmp	al,0Dh
	jz	@@done
	cmp	al,0Ah
	jz	@@done
	cmp	al,'"'
	jnz	@@cs1
	dec	edi
	jmp	@@notsp
@@juststore:
	stosb
	cmp	al,20h
	ja	@@notsp
@@done:
	mov	b [edi-1],0
	ret
;
ErrorTxt:	db 7,13,'ERROR!',10,0
AboutTxt: db 'Usage: lg2ext.exe <file.lap>',10,0
DumpTxt:	db `%02X: %s\n\0`

	section .bss

filetime	resd 2
outhandle	resd 1
resid	resd 1
ExitCode	resd 1
out_mem	resd 1
MEM		resd 1
LEN		resd 1
DirLen	resd 1
DirMem	resd 1
Handle	resd 1
InitOff	resd 1
CmdLine	resd 1
var_gs	resd 1
var_fs	resd 1
Header	resb 18h
FileName	resb	260
TextBuff	resb 16384
pack_type resb 1
WideString resb 1024

